
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class CalcFrame extends JFrame
{
	private JTextField display;
	private JButton[] keys;
	private JPanel keyPanel;
	private int operand;
	
	public CalcFrame()
	{
		Container c = getContentPane();
		c.setLayout( new BorderLayout() );
		display = new JTextField( 10 );
		keyPanel = new JPanel();
		c.add( display, "North" );
		c.add( keyPanel, "Center" );
		keyPanel.setLayout( new GridLayout(4,3));
        createButtons();
        createListeners();
	}
	
	private void createButtons()
	{
		keys = new JButton[12];
		for( int i = 0; i <= 9; i++ )
			keys[i] = new JButton( "" + i );
		keys[10] = new JButton( "+" );
		keys[11] = new JButton( "=" );
		for( int i = 1; i <= 10; i++ )
		   keyPanel.add( keys[i] );
		keyPanel.add( keys[0] );
		keyPanel.add( keys[11] );		
	}
	
	private void createListeners()
	{
		class BListener implements ActionListener
		{
			public void actionPerformed( ActionEvent ae )
			{
				JButton temp = (JButton) ae.getSource();
				String label = temp.getText();
				String contents = display.getText();
				display.setText( contents + label );
			}
		}
		ActionListener listen = new BListener();
		for( int i = 0; i <=9; i++ )
		   keys[i].addActionListener( listen );
		
		class PListener implements ActionListener
		{
			public void actionPerformed( ActionEvent ae )
			{
				String contents = display.getText();
				operand = Integer.parseInt( contents );
				display.setText( "" );
			}
		}
		keys[10].addActionListener( new PListener() );
		class EListener implements ActionListener
		{
			public void actionPerformed( ActionEvent ae )
			{
				String contents = display.getText();
				int sum = operand + Integer.parseInt( contents );
				display.setText( ""+sum );
			}
		}
		keys[11].addActionListener( new EListener() );
	}
}